/*
Copyright (c) 2006, John Stevens
All rights reserved.
E-mail : john AT jstevens DOT com

Non-commercial redistribution and use, with or without modification, 
is permitted provided that the following conditions are
met:

    * Redistributions must retain the above copyright
      notice, this list of conditions and the following disclaimer.

    * The name of John Stevens may not
      be used to endorse or promote products derived from this
      software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
var unlocked = true ;
var save_class, savetable_class, save_server_class, save_servertable_class ;

function click_refresh(theForm) {
 theForm.set_action.value = "Refresh" ;
 theForm.submit();
}

function click_delete(theForm,servername,line,event) {
 theForm.set_action.value = "Delete" ;
 theForm.set_server.value = servername ;
 theForm.set_line.value = line ;
 if(window.confirm("Do you really want to delete "+event+" from "+servername)) { theForm.submit(); }
}

function click_add(event,servername) {
var theForm ;
 
 theForm=document.getElementById("form_edit");
 theForm.set_action.value = "Add" ;
 theForm.update.value = "Add the new timer" ;
 theForm.select_server.selectedIndex = 0 ;
 document.getElementById("edit_servername").firstChild.nodeValue = servername ;
 
 // clear old values
 theForm.set_filename.value = "" ;
 theForm.set_channel.value  = "" ;
 theForm.set_start.value    = "" ;
 theForm.set_rectype.value = "" ;
 theForm.set_duration.value = "" ;
 theForm.set_padding.value  = "" ;
 
 // initialise new values
 theForm.set_server.value      = servername ;
 theForm.set_newname.value     = "New Recording Name" ;
 theForm.set_newchannel.selectedIndex=0;
 theForm.set_newstart.value    = "" ;  // Dummy value
 theForm.set_newrectype.selectedIndex=0;
 theForm.set_newdate.selectedIndex=0;
 theForm.set_newhour.value     = "20" ;
 theForm.set_newmin.value      = "00" ;
 change_datetime(theForm) ; // Build the default "Start" value
 theForm.set_newduration.value = default_duration ;
 theForm.set_newpadding.value  = default_padding ;
 
 // Get cursor position with respect to the page.

  if (browser.isIE) 
  {
    x = window.event.clientX + document.documentElement.scrollLeft
      + document.body.scrollLeft;
    y = window.event.clientY + document.documentElement.scrollTop
      + document.body.scrollTop;
  }
  if (browser.isNS) 
  {
    x = event.clientX + window.scrollX;
    y = event.clientY + window.scrollY;
  }

 document.getElementById("div_edit").style.top = (y+20)+"px" ;
 
 document.getElementById("div_string").firstChild.nodeValue = "Add a new timer";
 document.getElementById("edit_servername").style.display = "none";
 document.getElementById("edit_serverselect").style.display = "inline";
 document.getElementById("div_edit").style.visibility = "visible";
}

function click_edit(event,servername,filename,channel,start,rectype,duration,padding) {
var theForm, s1, s2, i ;

 theForm=document.getElementById("form_edit");
 theForm.set_action.value   = "Edit" ;
 theForm.update.value = "Update the timer" ;
 document.getElementById("edit_servername").firstChild.nodeValue = servername ;

 // store old values
 theForm.set_server.value   = servername ;
 theForm.set_filename.value = filename ;
 theForm.set_channel.value  = channel ;
 theForm.set_start.value    = start ;
 theForm.set_rectype.value  = rectype ;
 theForm.set_duration.value = duration ;
 theForm.set_padding.value  = padding ;
 
 // initialise new values
 theForm.set_newname.value     = filename ;
 theForm.set_newchannel.value  = channel ;
 theForm.set_newstart.value    = start ;
 s1=start.substring(0,10) ;
 for(i=0; i<number_days; i++)
 {
  s2=theForm.set_newdate.options[i].value ;
 	if(s2==s1)
	{
	 theForm.set_newdate.selectedIndex=i;
	}
 }
 theForm.set_newhour.value     = start.substring(11,13) ;
 theForm.set_newmin.value      = start.substring(14,16) ;
 for(i=0; i<theForm.set_newrectype.options.length; i++)
 {
  s2=theForm.set_newrectype.options[i].text ;
 	if(s2==rectype)
	{
	 theForm.set_newrectype.selectedIndex=i;
	}
 }
 theForm.set_newduration.value = duration ;
 theForm.set_newpadding.value  = padding ;
 change_rectype(theForm);  
 
 // Get cursor position with respect to the page.

  if (browser.isIE) 
  {
    x = window.event.clientX + document.documentElement.scrollLeft
      + document.body.scrollLeft;
    y = window.event.clientY + document.documentElement.scrollTop
      + document.body.scrollTop;
  }
  if (browser.isNS) 
  {
    x = event.clientX + window.scrollX;
    y = event.clientY + window.scrollY;
  }

 document.getElementById("div_edit").style.top = (y+20)+"px" ;

 
 document.getElementById("div_string").firstChild.nodeValue = filename + " on " + channel + " at " + start + " for " + duration + " minutes " + padding + " " + rectype ;
 document.getElementById("edit_servername").style.display = "inline";
 document.getElementById("edit_serverselect").style.display = "none";
 document.getElementById("div_edit").style.visibility = "visible";
}

function click_actionupdate(theForm) {
 theForm.set_newpadding.disabled = false ;  // make sure the field is enabled
 if(theForm.set_action.value == "Edit" )
 {
  if(window.confirm("Do you really want to change the timer "+theForm.set_filename.value)) { theForm.submit(); }
 }
 else
 {
  theForm.set_server.value = theForm.select_server.value ;
  theForm.submit();
 }
}

function change_datetime(theForm) {
 theForm.set_newstart.value = theForm.set_newdate.options[theForm.set_newdate.selectedIndex].value+" "+theForm.set_newhour.value+":"+theForm.set_newmin.value ;
}

function change_rectype(theForm) {

 if(theForm.set_newrectype.options[theForm.set_newrectype.selectedIndex].value == "pad")
 {
  theForm.set_newpadding.value = default_padding ;
	theForm.set_newpadding.disabled = false ;
 }
 else
 { 
  theForm.set_newpadding.value = theForm.set_newrectype.options[theForm.set_newrectype.selectedIndex].value ;
  theForm.set_newpadding.disabled = true ;
 }
 
}
function highlight_folder(theFolder,servernum,foldernum) {
 save_class = theFolder.className ;
 savetable_class = document.getElementById("table_folder_" + servernum + "_" + foldernum).className ;
 if(unlocked) 
 {
  theFolder.className = "directory_row_over" ; 
  document.getElementById("table_folder_" + servernum + "_" + foldernum).className = "table_folder_over" ;
 }
 return;
}

function lowlight_folder(theFolder,servernum,foldernum) {
 if(unlocked) 
 {
  theFolder.className = save_class ; 
  document.getElementById("table_folder_" + servernum + "_" + foldernum).className = savetable_class ;
 }
}

function click_folder(theFolder,servernum,foldernum,servername) { 
 var theForm ;
 //return ;  // temporary do nothing

 if (document.getElementById("div_folder_" + servernum + "_"  +foldernum).style.display=="block")
 {
   document.getElementById("div_folder_" + servernum + "_" + foldernum).style.display = "none" ;
   document.getElementById("img_folder_" + servernum + "_" + foldernum).src = closedImage.src ;
   save_expand(servername,foldernum,"n") ;
 }
 else
 {
   document.getElementById("div_folder_" + servernum + "_" + foldernum).style.display = "block" ;
   document.getElementById("img_folder_" + servernum + "_" + foldernum).src = openImage.src ;
   save_expand(servername,foldernum,"y") ;
 }
 return ;
}


function highlight_server(theServer,servernum) {
 save_server_class = theServer.className ;
 save_servertable_class = document.getElementById("table_server_" + servernum).className ;
 if(unlocked) 
 {
  theServer.className = "server_row_over" ; 
  document.getElementById("table_server_" + servernum).className = "table_server_over" ;
 }
}


function lowlight_server(theServer,servernum) {
 if(unlocked) 
  {
	theServer.className = save_server_class ; 
    document.getElementById("table_server_" + servernum).className = save_servertable_class ;
  }
}

function click_server(theServer,servernum,servername) { 
 var theForm ;

 if (document.getElementById("div_server_" + servernum).style.display=="block")
 {
   document.getElementById("div_server_" + servernum).style.display = "none" ;
   document.getElementById("img_server_" + servernum).src = closedImage.src ;
   save_expand(servername,0,"n") ;
 }
 else
 {
   document.getElementById("div_server_" + servernum).style.display = "block" ;
   document.getElementById("img_server_" + servernum).src = openImage.src ;
   save_expand(servername,0,"y") ;
 }
 return ;
}

function save_expand(servername,foldernum,val) {
  var theCookie ;
  theCookie = GetCookie("timers_expand_server[" + servername + "]") ;
  theCookie = theCookie.substr(0, foldernum) + val + theCookie.substr(foldernum + 1);
  SetCookie("timers_expand_server[" + servername + "]", theCookie) ;
  return ;
}


